﻿using CustomFiltering.Models;
using Kendo.Mvc;
using Kendo.Mvc.Extensions;
using Kendo.Mvc.UI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.Mvc;

namespace CustomFiltering.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.Message = "Welcome to ASP.NET MVC!";

            return View();
        }

        public ActionResult Virtualization_GetVisitor([DataSourceRequest] DataSourceRequest request)
        {
            return Json(GetVisitor().ToDataSourceResult(request));
        }

        public ActionResult Visitor(int[] values)
        {
            var indices = new List<int>();

            if (values != null && values.Any())
            {
                var index = 0;

                foreach (var visitor in GetVisitor())
                {
                    if (values.Contains(visitor.ID))
                    {
                        indices.Add(index);
                    }

                    index += 1;
                }
            }
            return Json(indices, JsonRequestBehavior.AllowGet);
        }

        private IQueryable<LookupViewModel> GetVisitor()
        {
            var ro = false;

            List<LookupViewModel> data = new List<LookupViewModel>()
            {
                new LookupViewModel() { ID = 1, FirstName = "Peter", MiddleName = "John",  LastName = "Who", Flag = true, SSN = "532-32-4111" },
                new LookupViewModel() { ID = 2, FirstName = "Andrw", MiddleName = "John",  LastName = "Who", Flag = true, SSN = "652-32-4111" },
                new LookupViewModel() { ID = 3, FirstName = "Ivan", MiddleName = "John",  LastName = "Who", Flag = false, SSN = "876-32-4111" },
                new LookupViewModel() { ID = 4, FirstName = "Penka", MiddleName = "John",  LastName = "Who", Flag = false, SSN = "123-32-4111" },
                new LookupViewModel() { ID = 5, FirstName = "Petkan", MiddleName = "John",  LastName = "Who", Flag = true, SSN = "029-32-4111" },
                new LookupViewModel() { ID = 6, FirstName = "Shumo", MiddleName = "John",  LastName = "Who", Flag = true, SSN = "541-32-4111" }
            };

            var result = data.Select(visitor => new LookupViewModel
            {
                ID = visitor.ID,
                FirstName = visitor.FirstName,
                MiddleName = visitor.MiddleName,
                LastName = visitor.LastName,
                Value = (visitor.Flag == true ? "FLAGGED " : "") +
                        visitor.FirstName + " " +
                        visitor.MiddleName + " " +
                        visitor.LastName +
                        " (" + (ro ? "XXX-XX-XXXX" : visitor.SSN.Replace("-", "")) + ") " +
                        (visitor.Flag == true ? "FLAGGED" : ""),
                Flagged = visitor.Flag == true ? "FLAGGED" : "",
                SSN = (ro ? "XXX-XX-XXXX" : visitor.SSN)
            });

            return result.AsQueryable();
        }
    }
}
